<?php
require_once '/var/www/ariannascreeningrepository/class/protected/class.database.php';

class Repository
{
    private $apiKey = "";
    private $msgType = "IN";                            // IN o OUT
    private $markAsPulled = 1;                          // 1 o 0 Segna come già letti
    private $getOnlyNotPulled = 1;                      // 1 o 0 Se deve tirarsi solo i messaggi che non si è già tirato
    private $number;
    private $destination;
    private $body;


    public function __construct($apikey = false)
    {


    }


    public function Repository()
    {


        self::__construct();
    }


    public function setDestination($number)
    {
        $this->destination = urlencode($number);
    }


    public function setApiKey($apiKey)
    {
        $this->apiKey = $apiKey;
    }

    public function setMsgType($msgType)
    {
        $this->msgType = $msgType;
    }

    public function setMarkAsPulled($markAsPulled)
    {
        $this->markAsPulled = $markAsPulled;
    }

    public function setGetOnlyNotPulled($getOnlyNotPulled)
    {
        $this->getOnlyNotPulled = $getOnlyNotPulled;
    }

    public function setNumber($number)
    {
        $this->number = $number;
    }


    public function getDestination()
    {
        return $this->destination;
    }


    function patientInfoRetrieve($patientId, $withHistory)
    {

        $oggetto = array();
        $dbrep = new Database();
        $sql = "SELECT 
*
FROM
Patient
WHERE
fiscalCode = '" . $patientId . "' LIMIT 1";

        $dbrep->query($sql);
        $row = mysqli_fetch_object($dbrep->result);
        $cfinpancia = $row->fiscalCode;
        if (strlen($cfinpancia) != '16') {

            $out['oggetto'] = $oggetto;
            $out['cf'] = '';
            return $out;
            die();
        }
        $oggetto = new stdClass;
        $Patient = new stdClass;
        $Patient->id = $row->id;
        $Patient->fiscalCode = $row->fiscalCode;
        $Patient->personalCode = $row->personalCode;
        $Patient->patientFamilyName = $row->patientFamilyName;
        $Patient->patientGivenName = $row->patientGivenName;
        $Patient->patientBirthDate = $row->patientBirthDate;
        $Patient->personalMobile = $row->personalMobile;
        $Patient->gender = $row->gender;
        $Patient->screeningTypeCode = $row->screeningTypeCode;
        $Patient->defExclusionDate = $row->defExclusionDate;
        $Patient->notResponderInvitationDate = $row->notResponderInvitationDate;
        $Patient->patientTelephone = $row->patientTelephone;
        $Patient->patientID = $row->patientID;
        $Patient->personalEmail = $row->personalEmail;
        $Patient->residenceAddress = $row->residenceAddress;
        $Patient->residenceMunicipalityCode = $row->residenceMunicipalityCode;
        $Patient->residenceZipCode = $row->residenceZipCode;
        $Patient->domicileAddress = $row->domicileAddress;
        $Patient->domicileMunicipalityCode = $row->domicileMunicipalityCode;
        $Patient->domicileZipCode = $row->domicileZipCode;
        $Patient->screeningAddress = $row->screeningAddress;
        $Patient->screeningMunicipalityCode = $row->screeningMunicipalityCode;
        $Patient->screeningZipCode = $row->screeningZipCode;
        $oggetto->Patient = $Patient;

        $Appointments = array();
        $sql = "SELECT * FROM Appointments WHERE cf_Patient = '" . $patientId . "' AND isConfirmAppointment !='0' AND isConfirmAppointment !='2' ORDER BY appointmentInvitationDate DESC";
        $dbrep->query($sql);

        $c = 0;
        while ($row = mysqli_fetch_object($dbrep->result)) {

            $appuntamento = new stdClass;
            $appuntamento->id = $row->id;
            $appuntamento->idAppointment = $row->idAppointment;
            $appuntamento->screeningTypeCode = $row->screeningTypeCode;
            $appuntamento->screeningTypeDisplayName = $row->screeningTypeDisplayName;
            $appuntamento->idResource = $row->idResource;
            $appuntamento->appointmentInvitationDate = $row->appointmentInvitationDate;
            $appuntamento->appointmentRealDate = $row->appointmentRealDate;
            $appuntamento->appointmentStateCode = $row->appointmentStateCode;
            $appuntamento->idExam = $row->idExam;
            $appuntamento->examDescription = $row->examDescription;
            $appuntamento->resourceDescription = $row->resourceDescription;
            $appuntamento->resourceAddress = $row->resourceAddress;
            $appuntamento->resourceTelephone = $row->resourceTelephone;
            $appuntamento->resourceHealthStructure = $row->resourceHealthStructure;
            $appuntamento->loginMessageType = $row->loginMessageType;
            $appuntamento->loginMessage = $row->loginMessage;
            $appuntamento->isConfirmAppointment = $row->isConfirmAppointment;
            $appuntamento->confirmAppointmentDate = $row->confirmAppointmentDate;
            $appuntamento->disdetto = $row->disdetto;
            $appuntamento->data_disdetta = $row->data_disdetta;
            $Appointments[$c] = $appuntamento;
            $c++;
        }

        $oggetto->Appointments = $Appointments;


        $Reports = array();

        $sql = "SELECT * FROM Reports WHERE cf_Patient = '" . $patientId . "'";
        $dbrep->query($sql);
        $c = 0;
        while ($row = mysqli_fetch_object($dbrep->result)) {
            $report = new stdClass;
            $report->idAppointment = $row->idAppointment;
            $report->idReport = $row->idReport;
            $report->appointmentResultCode = $row->appointmentResultCode;
            $report->reportUrl = $row->reportUrl;
            $report->reportPdfB64 = $row->reportPdfB64;
            $report->reportType = $row->reportType;
            $Reports[$c] = $report;
            $c++;
        }

        $oggetto->Reports = $Reports;

        $out['oggetto'] = $oggetto;
        $out['cf'] = $cfinpancia;

        return $out;
        die();
    }

    function appointmentConfirm($idAppointment,$action=false,$actionDate=false)
    {


        $out = array();
        $dbrep = new Database();
        $sql = "UPDATE Appointments set isConfirmAppointment='".$action."', confirmAppointmentDate=".(!$actionDate?'NOW()':''.$actionDate.'')." WHERE idAppointment='".$idAppointment."'";
        $dbrep->query($sql);
        $out['codiceRisultato'] = '150';
        $out['descrizioneRisultato'] = 'Appuntamento confermato correttamente';
        return $out;
        die();
    }



    function invitationDeclineReasonsRetrieve($screeningTypeCode,$idAppointment=false)
    {


        $out = array();
        $motivi = array();
        $dbrep = new Database();
        $sql = "SELECT * FROM Reasons WHERE screeningTypeCode='".$screeningTypeCode."'";
        $dbrep->query($sql);
        $c = 0;
        while($row = mysqli_fetch_object($dbrep->result)){
            $motivo = new stdClass;
            $motivo->declineReasonCode = $row->declineReasonCode;
            $motivo->declineReasonDescription = $row->declineReasonDescription;
            $motivi[$c] = $motivo;
            $c++;
        }
        $out['Motivi'] = $motivi;

        //return $out;

        die(json_encode($out['Motivi']));
    }

     function resourceSlotRetrieve($screeningTypeCode,$idResource,$fromDate,$toDate,$idExam,$idAppointment)
    {
        $out = array();
        $Resources = array();
        $Slots = array();
        $dbrep = new Database();
        $sql = "SELECT * FROM Resource WHERE idResource='".$idResource."'";
        //die(json_encode($sql));
        $dbrep->query($sql);
        $row = mysqli_fetch_object($dbrep->result);
        $Resource = new stdClass;
        $Resource->idResource=$row->idResource;
        $Resource->screeningTypeCode=$row->screeningTypeCode;
        $Resource->resourceDescription=$row->resourceDescription;
        $Resource->resourceAddress=$row->resourceAddress;
        $Resource->resourceTelephone=$row->resourceTelephone;
        $Resource->idExam=$row->idExam;
        $Resources[] = $Resource;

        $sql = "SELECT * FROM Slots WHERE idResource='".$idResource."' AND bandMaxSlots >0 AND (slotDate BETWEEN '".$fromDate."' AND '".$toDate."') LIMIT 2";//TOGLIERE IL LIMITE INSERITO SOLO PER COMODITA DI SVILUPPO
        //die(json_encode($sql));
        $dbrep->query($sql);
        $c = 0;
        while ($row = mysqli_fetch_object($dbrep->result)){
            $Slot = new stdClass;
            $Slot->idSlot = $row->idSlot;
            $Slot->idResource = $row->idResource;
            $Slot->slotBandType = $row->slotBandType;
            $Slot->slotDate = $row->slotDate.'T'.$row->slotStartTime;
            $Slot->slotStartTime = $row->slotStartTime;
            $Slot->slotEndTime = $row->slotEndTime;
            $Slot->bandMaxSlots = $row->bandMaxSlots;

            $Slots[$c] = $Slot;
        $c++;
        }

        $out['Resource'] = $Resource;
        $out['Slots'] = $Slots;
        die(json_encode($out));
    }

    function appointmentDelete($idPatient,$idAppointment,$invitationResult)
    {
        $response = array();
        $dbrep = new Database();
        $sql = "UPDATE Appointments set isConfirmAppointment='2', disdetto='1', data_disdetta=NOW(),invitationResult='".$invitationResult."'  WHERE idAppointment='".$idAppointment."'";
        $dbrep->query($sql);

        $response['result']['codiceRisultato']='100';
        $response['result']['descrizioneRisultato']='Appuntamento cancellato correttamente';
        die(json_encode($response));
    }
    function appointmentDeleteFake($idPatient,$idAppointment,$invitationResult,$IdSlotFake) // fintanto che il repository è artificiale
    {
        $response = array();
        $dbrep = new Database();
        $sql = "DELETE FROM Appointments WHERE idAppointment='".$idAppointment."'";
        $dbrep->query($sql);
        $sql="SELECT bandMaxSlots FROM Slots WHERE idSlot = '".$IdSlotFake."'";
        $dbrep->query($sql);
        $row = mysqli_fetch_object($dbrep->result);
        $bandMaxSlots = (int)$row->bandMaxSlots+1;
        $sql="UPDATE Slots SET bandMaxSlots='".$bandMaxSlots."' WHERE idSlot = '".$IdSlotFake."'";
        $dbrep->query($sql);
        $response['result']['codiceRisultato']='100';
        $response['result']['descrizioneRisultato']='Appuntamento cancellato correttamente';
        die(json_encode($response));
    }
    function appointmentCreate($screeningTypeCode,$idPatient,$newidExam,$newIdResource,$newDate,$newIdSlot,$isConfirmAppointment=false) //ATTENZIONARE PERCHE L'API NON PREVEDE IL PARAMETRO isConfirmAppointment io lo metto a 1 altrimenti vuoto o a 0 non li riprendo (CHIEDERE A CHRISTIAN PER LO SPOSTAMENTO é FONDAMENTALE)
    {

        $response = array();

        $Slots = array();
        $dbrep = new Database();



        $sql = "SELECT idAppointment FROM Appointments ORDER BY idAppointment DESC LIMIT 1";
        $dbrep->query($sql);
        $row = mysqli_fetch_object($dbrep->result);
        $newidAppointment = (int)$row->idAppointment+1;

        $sql = "SELECT * FROM Appointments WHERE idResource = '".$newIdResource."' AND screeningTypeCode = '".$screeningTypeCode."'";
        $dbrep->query($sql);
        $row = mysqli_fetch_object($dbrep->result);

        $sql = "INSERT INTO Appointments SET 
                cf_Patient = '".$idPatient."',
                idAppointment = $newidAppointment,
                screeningTypeCode = '".$screeningTypeCode."',
                screeningTypeDisplayName = '".$row->screeningTypeDisplayName."',
                idResource = $newIdResource,
                appointmentInvitationDate = '".$newDate."',
                appointmentRealDate = '".$newDate."',
                appointmentStateCode = '',
                idExam = $newidExam,
                examDescription = '".addslashes($row->examDescription)."',
                resourceDescription = '".addslashes($row->resourceDescription)."',
                resourceAddress = '".addslashes($row->resourceAddress)."',
                resourceTelephone = '".$row->resourceTelephone."',
                resourceHealthStructure = '".$row->resourceHealthStructure."',
                loginMessageType = '".$row->loginMessageType."',
                loginMessage = '".$row->loginMessage."',
                isConfirmAppointment = '".$isConfirmAppointment."',
                confirmAppointmentDate = '',
                disdetto = '',
                data_disdetta = '',
                invitationResult = '',
                for_reset = '1'";
//die('LAPAZZA'.$sql);
        $dbrep->query($sql);
        $sql="SELECT bandMaxSlots FROM Slots WHERE idSlot = '".$newIdSlot."'";
        $dbrep->query($sql);
        $row = mysqli_fetch_object($dbrep->result);
        $bandMaxSlots = (int)$row->bandMaxSlots-1;
        $sql="UPDATE Slots SET bandMaxSlots='".$bandMaxSlots."' WHERE idSlot = '".$newIdSlot."'";
        $dbrep->query($sql);
        $response['result']['codiceRisultato']='300';
        $response['result']['descrizioneRisultato']='Appuntamento creato correttamente';
        $response['appointment']['idAppointment']=$newidAppointment;
        $response['appointment']['screeningTypeCode']=$screeningTypeCode;
        //die('LAPAZZA 340'.json_encode($response));
        die(json_encode($response));
    }

    function appointmentCreate_xmove($screeningTypeCode,$idPatient,$newidExam,$newIdResource,$newDate,$newIdSlot,$isConfirmAppointment=false) //ATTENZIONARE PERCHE L'API NON PREVEDE IL PARAMETRO isConfirmAppointment io lo metto a 1 altrimenti vuoto o a 0 non li riprendo (CHIEDERE A CHRISTIAN PER LO SPOSTAMENTO é FONDAMENTALE)
    {

        $response = array();

        $Slots = array();
        $dbrep = new Database();
        $newDate=explode(" ",$newDate);
        $newDate=$newDate[0].'T'.$newDate[1];

$sql="SELECT idAppointment FROM Appointments WHERE 
                cf_Patient = '".$idPatient."' AND
                screeningTypeCode = '".$screeningTypeCode."' AND
                idResource = $newIdResource AND
                appointmentInvitationDate = '".$newDate."' AND
                appointmentRealDate = '".$newDate."' AND
                idExam = $newidExam AND
                isConfirmAppointment = '".$isConfirmAppointment."' LIMIT 1";

//die('LAPAZZA----361>'.$sql);

        $dbrep->query($sql);
        $row = mysqli_fetch_object($dbrep->result);
        $newidAppointment = $row->idAppointment;

        $response['appointment']['idAppointment']=$newidAppointment;
        $response['appointment']['screeningTypeCode']=$screeningTypeCode;
        return (json_encode($response));
    }


function appointmentMove($idPatient,$idAppointment,$newIdResource,$newDate,$newIdSlot){
    $dbrep = new Database();
    $sql = "SELECT * FROM Appointments WHERE idAppointment = '".$idAppointment."'";
    $dbrep->query($sql);
    $row = mysqli_fetch_object($dbrep->result);

    $new=self::appointmentCreate_xmove($row->screeningTypeCode,$idPatient,$row->idExam,$newIdResource,$newDate,$newIdSlot,$isConfirmAppointment=1);

    $new=json_decode($new);

    $newIdAppointment=$new->appointment->idAppointment;
    $response['result']['codiceRisultato']='200';
    $response['result']['descrizioneRisultato']='Appuntamento spostato correttamente';


    //concludere con la duplicazione del report
    $sql = "SELECT idReport FROM Reports ORDER BY idReport DESC LIMIT 1";
    $dbrep->query($sql);
    $row = mysqli_fetch_object($dbrep->result);
    $maxid = (int)$row->idReport + 1;

    $sql = "SELECT * FROM Reports WHERE cf_Patient='".$idPatient."' AND idAppointment = '".$idAppointment."' ";
    $dbrep->query($sql);
    $array=array();
    while($row = mysqli_fetch_object($dbrep->result)){
        $array[$row->idReport]['appointmentResultCode']=$row->appointmentResultCode;
        $array[$row->idReport]['reportUrl']=$row->reportUrl;
        $array[$row->idReport]['reportPdfB64']=$row->reportPdfB64;
        $array[$row->idReport]['reportType']=$row->reportType;
    }

    foreach ($array as $k=>$v){
        $sql="INSERT INTO Reports SET idReport=$maxid, idAppointment='".$newIdAppointment."', appointmentResultCode='".$v['appointmentResultCode']."', reportUrl='".$v['reportUrl']."', reportPdfB64='".$v['reportPdfB64']."', reportType='".$v['reportType']."', cf_Patient='".$idPatient."', for_reset='1' ";
        $dbrep->query($sql);
        $maxid++;
    }
    //die('LAPAZZA----------><pre>'.print_r($array,1).'</pre>');
    die(json_encode($response));

    }

function resettaCefpas(){
    $dbrep = new Database();
    $sql = "DELETE FROM Appointments WHERE for_reset = '1'";
    $dbrep->query($sql);
    $sql = "UPDATE Appointments SET isConfirmAppointment ='1' WHERE isConfirmAppointment !='1'";
    $dbrep->query($sql);

    $sql = "DELETE FROM Reports WHERE for_reset = '1'";
    $dbrep->query($sql);

    $sql = "UPDATE Slots SET bandMaxSlots ='1' WHERE bandMaxSlots !='1'";
    $dbrep->query($sql);

    die();

    }
}